<template>
  <!-- 九小场所添加 -->
  <div>
    <el-dialog :close-on-click-modal="false" :title="title + '工作提醒配置'" :visible.sync="showFormDia" width="76%"
      :before-close="handleClose" top="8vh">
      <div>
        <el-form ref="formInfo" :rules="rules" :model="params" label-width="160px">
          <p id="step1" class="from-title">
            <i class="el-icon-info" />
            <span>基本信息</span>
          </p>
          <el-row>
            <el-col :span="8">
              <el-form-item label="预警提醒业务" prop="warnBiz">
                <el-select @input="warnBizInput(params.warnBiz)" v-model="params.warnBiz" style="width:100%" clearable>
                  <el-option v-for="item in warnBizList" :key="item.value" :label="item.name" :value="item.value" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="预警提醒项" prop="warnBizItem">
                <el-select @input="warnBizItemInput(params.warnBizItem)" v-model="params.warnBizItem" style="width:100%"
                  clearable>
                  <el-option v-for="item in warnBizItemList" :key="item.value" :label="item.name" :value="item.value" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="预警名称" prop="title">
                <el-input v-model="params.title" placeholder="请输入预警名称" show-word-limit maxlength="100" />
              </el-form-item>
            </el-col>
          </el-row>

          <el-row>
            <el-col :span="8">
              <el-form-item label="预警阈值" prop="expireDay">
                <el-input v-model="params.expireDay" placeholder="请输入预警阈值" show-word-limit maxlength="100" />
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="预警产生说明" prop="warnRuleMemo">
                <el-input v-model="params.warnRuleMemo" placeholder="请输入预警产生说明" show-word-limit maxlength="100" />
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="预警规则" prop="warnRule">
                <el-select :disabled="true" v-model="params.warnRule" style="width:100%" clearable>
                  <el-option v-for="item in warnRuleList" :key="item.value" :label="item.name" :value="item.value" />
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>

          <!-- <el-row>
                <el-col :span="8">
                  <el-form-item label="预警规则方法名" prop="warnRuleMethod">
                    <el-input
                      v-model="params.warnRuleMethod"
                      maxlength="32"
                      placeholder="请输入预警规则方法名"
                    />
                  </el-form-item>
                </el-col>
                <el-col :span="8">
                  <el-form-item label="预警规则参数串" prop="warnRuleParameter">
                    <el-input
                      v-model="params.warnRuleParameter"
                      maxlength="32"
                      placeholder="请输入预警规则参数串"
                    />
                  </el-form-item>
                </el-col>
                <el-col :span="8">
                  <el-form-item label="预警提醒生产周期" prop="produceCyle">
                    <el-input
                      v-model="params.produceCyle"
                      maxlength="32"
                      placeholder="请输入预警提醒生产周期"
                    />
                  </el-form-item>
                </el-col>
              </el-row> -->

          <el-row>
            <el-col :span="16">
              <el-form-item label="预警规则执行类名" prop="warnRuleClass">
                <!-- maxlength="32" -->
                <el-input v-model="params.warnRuleClass" placeholder="请输入预警规则执行类名" show-word-limit maxlength="100" />
              </el-form-item>
            </el-col>

            <!-- <el-col :span="8">
                  <el-form-item label="提醒通知内容" prop="content">
                    <el-input
                      v-model="params.content"
                      maxlength="32"
                      placeholder="请输入提醒通知内容"
                    />
                  </el-form-item>
                </el-col> -->
            <el-col :span="8">
              <el-form-item label="预警紧急程度" prop="msgExigency">
                <el-select v-model="params.msgExigency" style="width:100%" clearable>
                  <el-option v-for="item in msgExigencyList" :key="item.value" :label="item.name" :value="item.value" />
                </el-select>
              </el-form-item>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="8">
              <el-form-item label="提醒方式" prop="remindType">
                <el-select v-model="params.remindType" style="width:100%" clearable>
                  <el-option v-for="item in remindTypeList" :key="item.value" :label="item.name" :value="item.value" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="通知范围" prop="remindRange">
                <el-select :disabled="true" v-model="params.remindRange" style="width:100%" clearable>
                  <el-option v-for="item in remindRangeList" :key="item.value" :label="item.name" :value="item.value" />
                </el-select>
              </el-form-item>
            </el-col>
            <el-col :span="8">
              <el-form-item label="接收提醒人员">
                <!-- <el-input
                      :readonly="true"
                      @focus="receiveUsersClick"
                      v-model="params.receiveUsers"
                      placeholder="请输入接收提醒人员"
                    /> -->
                <el-button @click="receiveUsersClick" type="primary">接收提醒人员
                </el-button>
              </el-form-item>
            </el-col>
          </el-row>

          <!-- <el-row>
                <el-col :span="8">
                  <el-form-item label="有效标志" prop="flag">
                    <el-select
                      v-model="params.flag"
                      style="width:100%"
                      clearable
                    >
                      <el-option
                        v-for="item in flagList"
                        :key="item.value"
                        :label="item.name"
                        :value="item.value"
                      />
                    </el-select>
                  </el-form-item>
                </el-col>
              </el-row> -->
        </el-form>
      </div>
      <span slot="footer" class="dialog-footer">
        <el-button type="primary" @click="handleSave">保 存</el-button>
        <el-button @click="handleClose">取 消</el-button>
      </span>
    </el-dialog>
    <el-dialog title="接收提醒人员" :visible.sync="dialogVisible" width="76%" :before-close="receiveUsersClose">
      <el-transfer @change="receiveUsersChange(params.receiveUsers)" v-model="params.receiveUsers"
        :data="userSelectOptions" :props="{
          key: 'id',
          label: 'fullname'
        }"></el-transfer>
      <span slot="footer" class="dialog-footer">
        <el-button @click="dialogVisible = false">取 消</el-button>
        <el-button type="primary" @click="dialogVisible = false">确 定</el-button>
      </span>
    </el-dialog>
  </div>
</template>
<script>
import CommonApi from '@/views/Manage/CommonApi.js'
import CmgtTSaftyWorkConfApi from '@/views/Manage/saftyDanger/api/CmgtTSaftyWorkConfApi'
import dictContracts from '@/components/dict/DictSelectUtils.js'
import dictUtils from '@/components/dict/DictSelectUtils.js'

export default {
  name: 'CmgtSaftyDangerUnitFormDialog',
  components: {},
  props: {},
  data() {
    return {
      userSelectOptions: [],
      dialogVisible: false,
      warnBizTitle: null,
      methodType: false,
      title: '新增',
      showFormDia: false,
      activeCollapseNames: ['1'],
      emphasisType: [],
      params: {
        // content: '',
        expireDay: '',
        flag: '1',
        msgExigency: '',
        // produceCyle: '',
        receiveUsers: [],
        remindRange: '',
        remindType: '',
        title: '',
        warnBiz: '',
        warnBizItem: '',
        warnRule: '',
        warnRuleClass: '',
        setUser: '',
        warnRuleMemo: ''
        // warnRuleMethod: '',
        // warnRuleParameter: ''
      },
      rules: {
        // type: [{
        // 	required: true,
        // 	message: '单位类别不能为空',
        // 	trigger: 'blur'
        // }],
        warnBiz: [
          {
            required: true,
            message: '预警提醒业务不能为空',
            trigger: 'blur'
          }
        ],
        warnBizItem: [
          {
            required: true,
            message: '预警提醒项不能为空',
            trigger: 'blur'
          }
        ],
        warnRule: [
          {
            required: true,
            message: '预警规则不能为空',
            trigger: 'blur'
          }
        ],
        expireDay: [
          {
            required: true,
            message: '产生预警提醒时间不能为空',
            trigger: 'blur'
          }
        ],
        warnRuleMemo: [
          {
            required: true,
            message: '预警产生说明不能为空',
            trigger: 'change'
          }
        ],
        warnRuleClass: [
          {
            required: true,
            message: '预警规则执行类名不能为空',
            trigger: 'blur'
          }
        ],
        warnRuleMethod: [
          {
            required: true,
            message: '预警规则执行方法名不能为空',
            trigger: 'blur'
          }
        ],
        title: [
          {
            required: true,
            message: '提醒标题不能为空',
            trigger: 'blur'
          }
        ],
        content: [
          {
            required: true,
            message: '提醒通知内容不能为空',
            trigger: 'blur'
          }
        ],
        msgExigency: [
          {
            required: true,
            message: '预警紧急程度不能为空',
            trigger: 'blur'
          }
        ],
        remindType: [
          {
            required: true,
            message: '提醒方式不能为空',
            trigger: 'blur'
          }
        ],
        remindRange: [
          {
            required: true,
            message: '通知范围不能为空',
            trigger: 'blur'
          }
        ],
        receiveUsers: [
          {
            required: true,
            message: '接收提醒人员不能为空',
            trigger: 'blur'
          }
        ],
        flag: [
          {
            required: true,
            message: '有效标志不能为空',
            trigger: 'blur'
          }
        ],
        produceCyle: [
          {
            required: true,
            message: '预警提醒生产周期不能为空',
            trigger: 'blur'
          }
        ]
      },
      // levels: [],
      types: []
    }
  },
  created() {
    this.types = dictContracts.getDictItemsFromCache('cmgt_aqyhpcdwlb')
    this.warnBizList = dictUtils.getDictItemsFromCache('yjtxyw')
    this.warnBizItemList = dictUtils.getDictItemsFromCache('yjtxx')
    this.warnRuleList = dictUtils.getDictItemsFromCache('yjgz')
    this.msgExigencyList = dictUtils.getDictItemsFromCache('yjjjcd')
    this.remindTypeList = dictUtils.getDictItemsFromCache('yjtxfs')
    this.remindRangeList = dictUtils.getDictItemsFromCache('tzfw')
    this.flagList = dictUtils.getDictItemsFromCache('yxbz')
    this.commonApiData()
    // this.levels = dictContracts.getDictItemsFromCache('cmgt_aqyhfxjb')
  },
  methods: {
    receiveUsersChange(val) {
      // console.log(val.length)
      if (this.userSelectOptions.length == val.length) {
        this.params.remindRange = '1'
      } else {
        this.params.remindRange = '2'
      }
    },
    receiveUsersClick() {
      this.dialogVisible = true
    },
    commonApiData() {
      CommonApi.loadSelectOptions(
        {
          name: 'manageCommonService.getAllUsers',
          query: ''
        },
        res => {
          // console.log('=========userSelectOptions=====', res)
          this.userSelectOptions = res
          // this.userSelectOptions.forEach(item => {
          //   this.tableData.forEach(v => {
          //     if (item.id == v.applicant) {
          //       // console.log(item, v)
          //       v.applicant = item.fullname
          //     }
          //   })
          // })
        }
      )
    },
    warnBizInput(val) {
      this.warnBizList.forEach(item => {
        if (item.value == val) {
          val = item.name
        }
      })
      this.warnBizTitle = val
    },
    //预警提醒项
    warnBizItemInput(val) {
      // console.log(val)
      if (val == '4') {
        this.params.warnRule = '2'
      } else {
        this.params.warnRule = '1'
      }
      this.warnBizItemList.forEach(item => {
        if (item.value == val) {
          val = item.name
        }
      })
      if (this.warnBizTitle !== null) {
        this.params.title = this.warnBizTitle + '-' + val
      }
    },
    //新增
    add() {
      this.showFormDia = true
      // this.params.emphasisTypeList = []
      // this.params.emphasisTypeList.push(this.zddwflList[0].value)
      // this.params.riskLevel = this.fxjbList[0].value
      // this.params.content = this.aqyhlxList[0].value
      // this.params.emphasisLevel = this.zddwjbList[0].value
      // this.params.fuelType = this.rlzlList[0].value
      // this.params.isShy = this.tysfList[0].value
    },
    handleClose() {
      this.params = {
        // content: '',
        expireDay: '',
        flag: '1',
        msgExigency: '',
        // produceCyle: '',
        receiveUsers: [],
        remindRange: '',
        remindType: '',
        title: '',
        warnBiz: '',
        warnBizItem: '',
        warnRule: '',
        warnRuleClass: '',
        setUser: '',
        warnRuleMemo: ''
        // warnRuleMethod: '',
        // warnRuleParameter: ''
      }

      this.title = '新增'
      this.showFormDia = false
    },
    receiveUsersClose() {
      this.dialogVisible = false
    },
    handleSave() {
      let params = JSON.parse(JSON.stringify(this.params))
      if (params.receiveUsers instanceof Array) {
        params.receiveUsers = params.receiveUsers.join(',')
      }
      params.setUser = JSON.parse(sessionStorage.getItem('currentUser')).userId
      // params.emphasisType = this.params.emphasisTypeList.join(',')
      // delete params.emphasisTypeList
      this.$refs.formInfo.validate(valid => {
        if (valid) {
          let method
          if (!this.params.id) {
            // 新增
            method = CmgtTSaftyWorkConfApi.cmgtWorkWarnConfCreate
          }
          if (this.params.id) {
            // 修改
            method = CmgtTSaftyWorkConfApi.cmgtWorkWarnConfUpdateById
          }
          method(params, res => {
            if (res.state) {
              this.$notify({
                type: 'success',
                message: this.title + '成功',
                duration: 2000
              })
              // this.$emit('loadData')
              this.$parent.loadData()
              this.handleClose()
            } else {
              this.$message.warning(res.message)
            }
          })
        }
      })
    },
    Update(row) {
      // console.log(row)
      this.title = '修改'
      this.showFormDia = true
      CmgtTSaftyWorkConfApi.cmgtWorkWarnConfId(row.id, res => {
        this.params = res
        this.params.receiveUsers = res.receiveUsers.split(',')
      })
    }
  }
}
</script>
<style lang="scss" scoped>
.step-container {
  width: 80%;
  margin: 0 auto 20px;
}

::v-deep .el-transfer__buttons {
  width: 10% !important;
  line-height: 15.41667vw !important;
}

.dialog-footer {
  text-align: center;
}
</style>
